public class Fader {
  
  private int blend;
  public Fader() {
    blend = 0;
  }
  
  public void restart() {
    blend = 0;
  }

  public boolean fadeout(int [] buffer1, int [] screen) {
    int n  = screen.length;
 
    blend += 32;
    int b = 1024-blend;
    for (int i = 0; i < n; i++) {
      int color1 = buffer1[i]; 
      
      int red1   = (color1 >> 16) & 0xff;
      int green1 = (color1 >>  8) & 0xff;
      int blue1  =  color1        & 0xff;
     
      int red   = ( (b * red1 ) >> 10); 
      int green = ( (b * green1 ) >> 10);
      int blue  = ( (b * blue1 ) >> 10);
      screen[ i ] = (0xff000000 | (red<<16) | (green<<8) | blue);
    }
    if (blend >= 1024)
      return false;
    return true;
  }

  public boolean render(int [] buffer1, int [] buffer2, int [] screen) {
    int n  = screen.length;

    blend += 16;
    for (int i = 0; i < n; i++) {

	int color1 = buffer1[i]; 
	
	int red1   = (color1 >> 16) & 0xff;
	int green1 = (color1 >>  8) & 0xff;
	int blue1  =  color1        & 0xff;
		
	int color2 = buffer2[i]; 
	
	int rDiff  = ((color2 >> 16) & 0xff) - red1;
	int gDiff  = ((color2 >>  8) & 0xff) - green1;
	int bDiff  = ( color2        & 0xff) - blue1;
		
	int red   = red1   + ( (blend * rDiff ) >> 10); //jaetaan maxBlendill
	int green = green1 + ( (blend * gDiff ) >> 10); //(1024)
	int blue  = blue1  + ( (blend * bDiff ) >> 10);
	

	screen[ i ] = (0xff000000 | (red<<16) | (green<<8) | blue);
    }
    if (blend >= 1024)
      return false;
    return true;
  }


}
