
public class Rotor  {
  private int[] sins = new int[256];
  private int[] coss = new int[256];
  
  private int w, h;
  private int alpha;
  public Rotor(int width, int heigth) {
    w = width;
    h = heigth;
    alpha = 0;
    initTrig();
  }

  private void initTrig() {
    for (int i = 0; i < 256; i++) {
      sins[i] = (int)(1024*Math.sin(  i*Math.PI / 128 ));
      coss[i] = (int)(1024*Math.cos(  i*Math.PI / 128 ));
    }
  }
  
  public void render(int [] texture, int [] screen) {
    alpha += 1;
    alpha = alpha & 0xff;

    int offs = 0;
    int minY = (-h>>1) - 50;
    int maxY = h+minY;
    int minX = -w>>1;
    int maxX = w+minX;

    int cs = coss[alpha];
    int ss = sins[alpha];
    

    for (int y = minY; y < maxY; y++) {
      for (int x = minX; x < maxX; x++) {

        //                        <<2  == tilt
	int x1 = ((cs*x  + ((ss*y)<<2))>>10) -minX;
	int y1 = ((-ss*x + ((cs*y)<<2))>>10) -minY;
        
        if (x1 < 0) do { x1 += w; } while(x1 < 0);
        else if (x1 >= w) do { x1 -= w; } while(x1 >=w);
        if (y1 < 0) do { y1 += h; } while(y1 < 0);
        else if (y1 >= h) do { y1 -= h; } while(y1 >=h);
        screen[ offs++ ] = texture[y1*w+x1];
      }
    }
  }
}
